using Terminal;
using db;
using System.Collections.Generic;
using System.Threading.Tasks;
using PLCS7;
using System;
using System.Text;
using MySql.Data.MySqlClient;
using System.Threading;
using BroadcastModule;
using parkMonitor.LOG;

namespace Terminal
{
    public class Terminal
    {
        public static List<TerminalStru> terminalInfo = new List<PLCS7.TerminalStru>();
        public static Dictionary<int, string> idLicMap = new Dictionary<int, string>();
        public static Dictionary<int, bool> termUsedMap = new Dictionary<int, bool>();
        public static bool isClosing = false;

        public void FeeCal()
        {

        }

        public void GetTerminalState()
        {

        }

        private object SearchPaymentScheme()
        {
            return null;
        }

        private void UpdateParkingRecords(int Object)
        {

        }

        /// <summary>
        /// ն˽ṹлóƺ
        /// </summary>
        /// <param name="ts"></param>
        /// <returns></returns>
        private static string GetLicenseFromTerm(TerminalStru ts)
        {
            string header = Encoding.ASCII.GetString(BitConverter.GetBytes(ts.licenseCodeB));
            string identityA = Encoding.ASCII.GetString(BitConverter.GetBytes(ts.licenseCodeC));
            byte[] bytes = BitConverter.GetBytes(ts.licenseCodeD);
            List<byte> newBytes = new List<byte>();
            for (int i = 0; i < bytes.Length; i++)
            {
                if (bytes[i] != 0x00) { newBytes.Add(bytes[i]); }
            }
            string identityB = Encoding.ASCII.GetString(newBytes.ToArray());
            Log.WriteLog(LogType.process, LogFile.INFO, "Ѵն" + ts.terminalID + "úƣ" + header + identityA + identityB);
            //ʡݶӦλֲҺ
            string province = header.Substring(0, 2);
            string provinceIndex = header.Substring(2);
            string provinceQuerySql = "select NumberPlateHeader from numberplatemapping where mappedString = " + province + ";";
            lock (Monitor.Monitor.localDBOper)
            {
                object[] result = Monitor.Monitor.localDBOper.Query(provinceQuerySql);
                //MySqlDataReader reader = Monitor.Monitor.localDBOper.Query(provinceQuerySql);
                try
                {
                    //if (reader != null && reader.Read() && reader.HasRows)
                    //{
                    //    province = reader.GetString("NumberPlateHeader");
                    //    //Console.WriteLine(province);
                    //}
                    if (result!=null && result.Length > 0) { province = (string)result[0]; }
                }
                catch { }
                //if (reader != null)
                //{
                //    reader.Close();
                //    reader.Dispose();
                //}
            }
            return province + provinceIndex + identityA + identityB;
        }
        /// <summary>
        /// гλϢ
        /// </summary>
        private static void UpdateAllParkingSpace()
        {
            string findParkingSpace = "select parkingSpaceID from parkingspace;";
            HashSet<int> recordsIDSet = new HashSet<int>();
            lock (Monitor.Monitor.localDBOper)
            {
                object[] result = Monitor.Monitor.localDBOper.Query(findParkingSpace);
                if(result!=null && result.Length > 0)
                {
                    for (int i = 0; i < result.Length; i++)
                    {
                        recordsIDSet.Add((int)result[i]);
                    }
                }
                //MySqlDataReader reader = Monitor.Monitor.localDBOper.Query(findParkingSpace);
                //if (reader != null)
                //{
                //    while (reader.Read())
                //    {
                //        if (reader.HasRows)
                //        {
                //            recordsIDSet.Add(reader.GetInt32("parkingSpaceID"));
                //        }
                //    }
                //}
                //try
                //{
                //    if (reader != null)
                //    {
                //        reader.Close();
                //        reader.Dispose();
                //    }
                //}
                //catch { }
            }
            List<string> updateSpaceList = new List<string>();
            List<string> insertSpaceList = new List<string>();
            string updateParkingSpace = "";
            string insertParkingSpace = "";
            for (int i = 0; i < Monitor.Monitor.parkingSpaceInfo.Count; i++)
            {
                if (recordsIDSet.Contains(Monitor.Monitor.parkingSpaceInfo[i].parkingSpace))
                {
                    updateParkingSpace = "update parkingspace set parkingSpaceX = " + Monitor.Monitor.parkingSpaceInfo[i].coordX +
                        ",parkingSpaceY = " + Monitor.Monitor.parkingSpaceInfo[i].coordY + ",parkingSpaceZ = " + Monitor.Monitor.parkingSpaceInfo[i].floorNo + ",parkingSpaceState = " + Monitor.Monitor.parkingSpaceInfo[i].spaceStatus + " where (parkingSpaceID = " + Monitor.Monitor.parkingSpaceInfo[i].parkingSpace + ");";
                    updateSpaceList.Add(updateParkingSpace);
                }
                else
                {
                    insertParkingSpace = "insert into parkingspace (parkingSpaceID,parkingSpaceX,parkingSpaceY,parkingSpaceZ,parkingSpaceState) values (" + Monitor.Monitor.parkingSpaceInfo[i].parkingSpace + "," + Monitor.Monitor.parkingSpaceInfo[i].coordX +
                        "," + Monitor.Monitor.parkingSpaceInfo[i].coordY + "," + Monitor.Monitor.parkingSpaceInfo[i].floorNo + "," + Monitor.Monitor.parkingSpaceInfo[i].spaceStatus + ");";
                    insertSpaceList.Add(insertParkingSpace);
                }
            }
            try
            {
                lock (Monitor.Monitor.localDBOper)
                {
                    Monitor.Monitor.localDBOper.UpdateTransaction(updateSpaceList);
                    Monitor.Monitor.localDBOper.Insert(insertSpaceList);
                }
            }
            catch (Exception e) { Log.WriteLog(LogType.process, LogFile.ERROR, "±гλ쳣"); Console.WriteLine("±гλ쳣" + e.Message); }
        }
        /// <summary>
        /// ³״̬
        /// </summary>
        /// <param name="lic"></param>
        /// <param name="state"></param>
        private static void UpdateVehicle(string lic, int state, int parkingRecordsID, bool park, bool remote, int parkingSpaceID)
        {
            if (lic != "")
            {
                //MySqlDataReader reader;
                object[] result;
                //ѯǷڳ
                string checkVehicleState = "select * from vehicle where numberPlate = '" + lic + "';";
                if (!remote)
                {
                    //reader = Monitor.Monitor.localDBOper.Query(checkVehicleState);
                    result = Monitor.Monitor.localDBOper.Query(checkVehicleState);
                }
                else
                {
                    //reader = Monitor.Monitor.remoteDBOper.Query(checkVehicleState);
                    result = Monitor.Monitor.remoteDBOper.Query(checkVehicleState);
                }
                //if (reader != null && reader.Read() && reader.HasRows)
                //{
                //    try
                //    {
                //        reader.Close();
                //        reader.Dispose();
                //    }
                //    catch { }
                if(result!=null && result.Length > 0) { 
                    //³״̬
                    string updateVehicleState = "";
                    string updateRemoteVehicleState = "";
                    if (park)
                    {
                        if (parkingRecordsID > 0)
                        {
                            if (parkingSpaceID == 0)
                            {
                                updateVehicleState = "update vehicle set vehiclepParkState = " + state + " ,parkingRecordsID = " + parkingRecordsID + " where numberPlate = '" + lic + "';";
                                updateRemoteVehicleState = "update vehicle set vehiclepParkState = " + state + " ,parkingRecordsID = " + parkingRecordsID + ",garageID = " + Monitor.Monitor.garageID + "where numberPlate = '" + lic + "';";
                            }
                            else
                            {
                                updateVehicleState = "update vehicle set vehiclepParkState = " + state + " ,parkingRecordsID = " + parkingRecordsID + ",parkingSpaceID = " + parkingSpaceID + " where numberPlate = '" + lic + "';";
                                updateRemoteVehicleState = "update vehicle set vehiclepParkState = " + state + " ,parkingRecordsID = " + parkingRecordsID + ",parkingSpaceID = " + parkingSpaceID + ",garageID = " + Monitor.Monitor.garageID + "where numberPlate = '" + lic + "';";
                            }
                        }
                        else
                        {
                            updateVehicleState = "update vehicle set vehiclepParkState = " + state + " where numberPlate = '" + lic + "';";
                            updateRemoteVehicleState = updateVehicleState;
                        }
                    }
                    else
                    {
                        updateVehicleState = "update vehicle set vehiclepParkState = " + state + " where numberPlate = '" + lic + "';";
                        updateRemoteVehicleState = updateVehicleState;
                    }
                    List<string> list = new List<string>();
                    list.Add(updateVehicleState);
                    if (!remote)
                    {
                        Monitor.Monitor.localDBOper.UpdateTransaction(list);
                    }
                    else
                    {
                        Monitor.Monitor.remoteDBOper.UpdateTransaction(list);
                    }
                    
                }
                else
                {
                    //복
                    string insertVehicleWithState = "";
                    if (park)
                    {
                        if (parkingRecordsID > 0)
                            insertVehicleWithState = "insert into vehicle (numberPlate,vehicleTypeID,vehiclepParkState,parkingRecordsID) values " +
                        "('" + lic + "',NULL,'" + state + "'," + parkingRecordsID + ");";
                        else
                            insertVehicleWithState = "insert into vehicle (numberPlate,vehicleTypeID,vehiclepParkState) values " +
                        "('" + lic + "',NULL,'" + state + "');";
                    }
                    else
                    {
                        Log.WriteLog(LogType.process, LogFile.ERROR, "ȡ޷óϢ");
                        Console.WriteLine("쳣ȡ޳");
                        return;
                    }

                    List<string> list = new List<string>();
                    list.Add(insertVehicleWithState);
                    if (!remote)
                    {
                        Monitor.Monitor.localDBOper.Insert(list);
                    }
                    else
                    {
                        Monitor.Monitor.remoteDBOper.Insert(list);
                    }
                }
                
            }
        }
        /// <summary>
        /// ̽նϢ
        /// </summary>
        /// <param name="id"></param>
        private static void ClearTerminal(int id)
        {
            TerminalStru tsFromCentral = new TerminalStru
            {
                terminalID = (short)id,
                parkingFee = (short)32767,
            };
            TerminalStru tsFromTerminal = new TerminalStru
            {
                terminalID = (short)id,
                btnStatus = -1,
            };
            Monitor.Monitor.PLC.WriteToPLC(tsFromCentral, PLCDataType.central);
            Monitor.Monitor.PLC.WriteToPLC(tsFromTerminal, PLCDataType.terminal);
        }

        /// <summary>
        /// ̣ͣյƻ
        /// </summary>
        private static void ParkNumSubProcess()
        {
            int numMachineLaunch = Monitor.Monitor.mainBlockInfo.numMachineLaunch;
            if (numMachineLaunch != 0)
            {
                for (int i = 0; i < terminalInfo.Count; i++)
                {
                    //ָնidƥ
                    if (numMachineLaunch == terminalInfo[i].terminalID)
                    {
                        int numReceivedStatus = 0;//1ã2ֹ
                        TerminalStru term = terminalInfo[i];
                        if (term.terminalStatus == (short)1)
                        {
                            string license = Monitor.Monitor.numMachineLinker.GetLicensePlate(numMachineLaunch);
                            //δúƣ֪PLCֹնʾû²
                            if (license == "")
                            {
                                MainBlockStru mb = new MainBlockStru
                                {
                                    licenseReceived = (short)2
                                };
                                Monitor.Monitor.PLC.WriteToPLC(mb, PLCDataType.central);
                                TerminalStru ts = new TerminalStru
                                {
                                    terminalID = (short)numMachineLaunch,
                                    paymentStatus = -1,
                                    parkingFee = -1,
                                    userType = -1,
                                    licVerification = (short)2
                                };
                                Monitor.Monitor.PLC.WriteToPLC(ts, PLCDataType.central);
                                Log.WriteLog(LogType.process, LogFile.ERROR, "δú");
                            }
                            else
                            {
                                //¼µǰ
                                lock (idLicMap)
                                {
                                    if (idLicMap.ContainsKey(numMachineLaunch))
                                    {
                                        idLicMap[numMachineLaunch] = license;
                                    }
                                    else
                                    {
                                        idLicMap.Add(numMachineLaunch, license);
                                    }
                                }
                                Log.WriteLog(LogType.process, LogFile.ERROR, "" + license + "Ѽ¼");

                                TerminalStru ts = new TerminalStru
                                {
                                    terminalID = (short)numMachineLaunch,
                                    paymentStatus = -1,
                                    parkingFee = -1,
                                    userType = -1
                                };
                                //עû
                                if (term.btnStatus == (short)2)
                                {
                                    int userID = term.licenseCodeA;
                                    string userLicense = GetLicenseFromTerm(term);
                                    //ƶݱȶ
                                    string checkNetSql = "select * from user where userID = 1;";
                                    object[] result = Monitor.Monitor.remoteDBOper.Query(checkNetSql);
                                    //MySqlDataReader readerTest = Monitor.Monitor.remoteDBOper.Query(checkNetSql);
                                    //if ( readerTest!= null && readerTest.Read() && readerTest.HasRows)
                                    //{
                                    //    try
                                    //    {
                                    //        readerTest.Close();
                                    //        readerTest.Dispose();
                                    //    }
                                    //    catch { }
                                    if (result!=null && result.Length>0) { 
                                        string userInfoCheckSql = "select * from usercarrelation where userID = '" + userID + "'and numberPlate = '" + userLicense + "';";
                                        //MySqlDataReader reader = Monitor.Monitor.remoteDBOper.Query(userInfoCheckSql);
                                        object[] objList = Monitor.Monitor.remoteDBOper.Query(userInfoCheckSql);
                                        //if (reader != null && reader.Read() && reader.HasRows && userID != 0 && userLicense != "")
                                        if(objList!=null && objList.Length>0 && userID != 0 && userLicense != "")
                                        {
                                            ts.licVerification = 1;//֤ɹ
                                            Monitor.Monitor.PLC.WriteToPLC(ts, PLCDataType.central);
                                            numReceivedStatus = 1;
                                            Log.WriteLog(LogType.process, LogFile.INFO, "֤ɹ");
                                        }
                                        else
                                        {
                                            ts.licVerification = 2;//֤ʧ
                                            Monitor.Monitor.PLC.WriteToPLC(ts, PLCDataType.central);
                                            numReceivedStatus = 2;
                                            Log.WriteLog(LogType.process, LogFile.WARNING, "֤ʧ");
                                        }
                                        //try
                                        //{
                                        //    reader.Close();
                                        //    reader.Dispose();
                                        //}
                                        //catch { }
                                    }
                                    else
                                    {
                                        ts.licVerification = 1;//쳣֤
                                        Monitor.Monitor.PLC.WriteToPLC(ts, PLCDataType.central);
                                        numReceivedStatus = 1;
                                        Log.WriteLog(LogType.process, LogFile.ERROR, "쳣޷֤");
                                    }
                                }
                                //עû
                                else if (term.btnStatus == (short)1)
                                {
                                    numReceivedStatus = 1;
                                    ts.licVerification = 1;
                                    Monitor.Monitor.PLC.WriteToPLC(ts, PLCDataType.central);
                                }
                                //ǷעᣬԸ֪PLCѻȡƻȶ쳣ֹ
                                MainBlockStru mb = new MainBlockStru
                                {
                                    licenseReceived = (short)numReceivedStatus
                                };
                                Monitor.Monitor.PLC.WriteToPLC(mb, PLCDataType.central);
                                //ƻȡ
                                while (Monitor.Monitor.mainBlockInfo.numMachineLaunch != 0)
                                {
                                    Thread.Sleep(2000);
                                }
                            }
                        }
                    }
                }
            }
        }
        /// <summary>
        /// ̣ͣյPLCͣźź
        /// </summary>
        private static void ParkCompleteSubProcess()
        {
            int processAttrib = Monitor.Monitor.mainBlockInfo.parkingRunning;
            int processCompleted = Monitor.Monitor.mainBlockInfo.processCompleted;
            int currentTerm = Monitor.Monitor.mainBlockInfo.terminalID;
            int parkingSpaceID = 0;
            if (processAttrib == 1 && processCompleted == 1)
            {
                TerminalStru term;
                string license;
                //ҵն˺ţжǷעû
                for (int i = 0; i < terminalInfo.Count; i++)
                {
                    //õ
                    if (terminalInfo[i].terminalID == currentTerm && idLicMap.TryGetValue(currentTerm, out license) && license != "")
                    {
                        term = terminalInfo[i];
                        //ҵͣλ
                        for (int s = 0; s < Monitor.Monitor.parkingSpaceInfo.Count; s++)
                        {
                            if (Monitor.Monitor.parkingSpaceInfo[i].receiptNum == term.receiptNum)
                            {
                                parkingSpaceID = Monitor.Monitor.parkingSpaceInfo[i].parkingSpace;
                                break;
                            }
                        }
                        //޳λϢǰѭ
                        if (parkingSpaceID == 0) break;
                        UpdateVehicle(license, 0, 0, true, false,0);
                        UpdateVehicle(license, 0, 0, true, true,0);
                        //ͣ¼
                        string parkingRecordsSql = "";
                        if (term.licenseCodeA != 0)
                        {
                            parkingRecordsSql = "INSERT INTO parkingrecords (userID, numberPlate,parkingSpaceID,garageID,parkingRecordsState,realParkTime,receiptNum,parkingPrice)" +
                                "values ('" + term.licenseCodeA + "','" + license + "','" + parkingSpaceID + "','" + Monitor.Monitor.garageID + "',3,'" + DateTime.Now.ToLocalTime().ToString("yyyy-MM-dd HH:mm:ss") + "','" + term.receiptNum + "',NULL);";
                        }
                        else
                        {
                            parkingRecordsSql = "INSERT INTO parkingrecords (userID, numberPlate,parkingSpaceID,garageID,parkingRecordsState,realParkTime,receiptNum,parkingPrice)" +
                                "values ('" + 1 + "','" + license + "','" + parkingSpaceID + "','" + Monitor.Monitor.garageID + "',3,'" + DateTime.Now.ToLocalTime().ToString("yyyy-MM-dd HH:mm:ss") + "','" + term.receiptNum + "',NULL);";
                        }
                        List<string> list = new List<string>();
                        list.Add(parkingRecordsSql);
                        Monitor.Monitor.localDBOper.Insert(list);
                        Monitor.Monitor.remoteDBOper.Insert(list);
                        Log.WriteLog(LogType.process, LogFile.INFO, "ͣ¼Ѳ");
                        ////עû¼ƶ
                        //if (term.btnStatus == 0)
                        //{
                        //Monitor.Monitor.remoteDBOper.Insert(list);
                        //}
                        //ѯ¼ID
                        string findRecordSql = "select parkingRecordsID from parkingrecords where receiptNum = " + term.receiptNum + ";";
                        object[] localRecords = Monitor.Monitor.localDBOper.Query(findRecordSql);
                        object[] remoteRecords = Monitor.Monitor.remoteDBOper.Query(findRecordSql);
                        //MySqlDataReader reader = Monitor.Monitor.localDBOper.Query(findRecordSql);
                        //MySqlDataReader remoteReader = Monitor.Monitor.remoteDBOper.Query(findRecordSql);
                        int parkingRecordsID = 0;
                        int remoteParkingRecordsID = 0;
                        try
                        {
                            //if (reader != null && reader.Read())
                            //{
                            //    parkingRecordsID = reader.GetInt32("parkingRecordsID");
                            //    try
                            //    {
                            //        if (reader != null)
                            //        {
                            //            reader.Close();
                            //            reader.Dispose();
                            //        }
                            //    }
                            //    catch { }
                            //}
                            //if (remoteReader != null && remoteReader.Read())
                            //{
                            //    remoteParkingRecordsID = remoteReader.GetInt32("parkingRecordsID");
                            //    try
                            //    {
                            //        if (remoteReader != null)
                            //        {
                            //            remoteReader.Close();
                            //            remoteReader.Dispose();
                            //        }
                            //    }
                            //    catch { }
                            //}
                            if(localRecords!=null && localRecords.Length > 0) { parkingRecordsID = (int)localRecords[0]; }
                            if (remoteRecords != null && remoteRecords.Length > 0) { remoteParkingRecordsID = (int)remoteRecords[0]; }
                        }
                        catch (Exception e) { Log.WriteLog(LogType.process, LogFile.ERROR, "ѯͣ¼idʧ"); ; Console.WriteLine(e.Message); };
                        //±س
                        if (parkingRecordsID != 0)
                        {
                            UpdateVehicle(license, 1, parkingRecordsID, true, false, parkingSpaceID);
                        }
                        if (remoteParkingRecordsID != 0)
                        {
                            UpdateVehicle(license, 1, remoteParkingRecordsID, true, true, parkingSpaceID);
                        }
                        Log.WriteLog(LogType.process, LogFile.INFO, "ͣ¼Ѹ");
                        //±سλ
                        UpdateAllParkingSpace();
                        while (Monitor.Monitor.mainBlockInfo.processCompleted != 0)
                        {
                            Thread.Sleep(1000);
                        }
                        //пơƾ֤š֤Ϣ
                        ClearTerminal(term.terminalID);
                    }
                }
            }
        }

        /// <summary>
        /// ͣز
        /// 1.ȡƻָƻǷעûв
        ///     עõƺ¼֪plc
        ///     עû˶ԺûϢ
        /// 2.ͣ̽,дݿ
        /// </summary>
        /// 
        private static void ParkProcess()
        {
            Task.Factory.StartNew(() =>
            {
                while (!isClosing)
                {
                    ParkNumSubProcess();
                    Thread.Sleep(Monitor.Monitor.plcRefreshInterval);
                }
            });

            Task.Factory.StartNew(() =>
            {
                while (!isClosing)
                {
                    ParkCompleteSubProcess();
                    Thread.Sleep(Monitor.Monitor.plcRefreshInterval);
                }
            });
        }

        /// <summary>
        /// ƾ֤Ųѯͣ¼
        /// </summary>
        /// <param name="receipt"></param>
        /// <param name="recordID"></param>
        /// <param name="userID"></param>
        /// <param name="numberPlate"></param>
        /// <param name="realParkTime"></param>
        private static bool FindLocalParkingRecord(int receipt, out int recordID, out int userID, out string numberPlate, out string realParkTime)
        {
            recordID = 0;
            userID = 0;
            numberPlate = "";
            realParkTime = "";
            string parkRecordsSql = "select parkingRecordsID,userID,numberPlate,realParkTime from parkingrecords where receiptNum = " + receipt + ";";
            try
            {
                object[] result = Monitor.Monitor.localDBOper.Query(parkRecordsSql);
                if(result!=null && result.Length >= 4)
                {
                    recordID = (int)result[0];
                    userID = (int)result[1];
                    numberPlate = (string)result[2];
                    realParkTime = (string)result[3];
                }
                //MySqlDataReader reader = Monitor.Monitor.localDBOper.Query(parkRecordsSql);
                //if (reader != null && reader.Read())
                //{
                //    object[] receiver = new object[4];
                //    reader.GetValues(receiver);
                //    recordID = (int)receiver[0];
                //    userID = (int)receiver[1];
                //    numberPlate = (string)receiver[2];
                //    realParkTime = (string)receiver[3];
                //}
                //if (reader != null)
                //{
                //    reader.Close();
                //    reader.Dispose();
                //}

            }
            catch (Exception e) { Log.WriteLog(LogType.process, LogFile.ERROR, "ƾ֤Ųѯͣ¼ʧ"); Console.WriteLine(e.Message); return false; }
            Log.WriteLog(LogType.process, LogFile.INFO, "ƾ֤Ųѯͣ¼ɹ");
            return true;
        }

        /// <summary>
        /// ԤԼͣü
        /// </summary>
        /// <param name="scheme"></param>
        /// <param name="parkTime"></param>
        /// <param name="orderTimeLength"></param>
        /// <returns></returns>
        private static int FeeCalc(PaymentScheme scheme, DateTime parkTime, TimeSpan orderTimeLength)
        {
            try
            {
                int orderFee = scheme.bookCharge * (int)orderTimeLength.TotalHours;
                int parkFee = 0;
                int hours = (int)(DateTime.Now - parkTime).TotalHours;
                switch (scheme.schemeType)
                {
                    //ʱƷ
                    case 1:
                        if (hours > scheme.firstChargeTime)
                        {
                            parkFee = Math.Min(scheme.firstCharge + scheme.intervalCharge * hours / scheme.chargeInterval, scheme.upperBound);
                        }
                        else
                        {
                            parkFee = scheme.firstCharge;
                        }
                        break;
                    //μƷ
                    case 2:
                        int overnightCount = hours / 24;
                        parkFee = scheme.eachCharge + overnightCount * scheme.overnightCharge;
                        break;
                    //ʱμƷ
                    case 3:
                        TimeSpan currentTimeOfDay = DateTime.Now.TimeOfDay;
                        TimeSpan parkTimeOfDay = parkTime.TimeOfDay;
                        TimeSpan startTimeOfDay = DateTime.Parse(scheme.startChargeTime).TimeOfDay;
                        TimeSpan endTimeOfDay = DateTime.Parse(scheme.endChargeTime).TimeOfDay;
                        double countingHoursOfDay = endTimeOfDay.TotalHours - startTimeOfDay.TotalHours;
                        int days = (int)((DateTime.Now - parkTime).TotalHours - currentTimeOfDay.TotalHours + parkTimeOfDay.TotalHours);
                        int previousOffset = (int)(-(Math.Max(0, parkTimeOfDay.TotalHours - startTimeOfDay.TotalHours)));
                        int currentOffset = (int)Math.Min((currentTimeOfDay.TotalHours - startTimeOfDay.TotalHours), countingHoursOfDay);
                        parkFee = (days * (int)countingHoursOfDay + previousOffset + currentOffset) * scheme.chargeStandard;
                        break;
                }
                Log.WriteLog(LogType.process, LogFile.INFO, "ͣ" + parkFee);
                return parkFee;
            }
            catch (Exception e) { Console.WriteLine("ü쳣"); return -1; }
        }

        /// <summary>
        /// ȡƷӲ
        /// </summary>
        private static void FetchFeeCalcSubProcess()
        {
            int fetchState = Monitor.Monitor.mainBlockInfo.fetchingRunning;
            int receiptNum = 0;
            int termIndex = -1;
            TerminalStru ts = new TerminalStru();
            for (int i = 0; i < terminalInfo.Count; i++)
            {
                if (terminalInfo[i].terminalID == Monitor.Monitor.mainBlockInfo.terminalID)
                {
                    ts = terminalInfo[i];
                    termIndex = ts.terminalID;
                    receiptNum = ts.receiptNum;
                    break;
                }
            }
            //ȡ״̬ƾ֤ŲΪգѯݿƷ
            if (termIndex != -1 && termUsedMap.Count >= termIndex && termUsedMap.TryGetValue(termIndex, out bool value) && !value && fetchState == 1 && receiptNum != 0)
            {
                termUsedMap[termIndex] = true;
                Console.WriteLine("ն˱" + termIndex);
                Task.Factory.StartNew(() =>
                {
                    int parkingRecordsID = 0;
                    int remoteParkingRecordsID = 0;
                    int userID = 0;
                    string numberPlate = "";
                    string realParkTime = "";
                    //1.ƾ֤Ųѯͣ¼
                    if (!FindLocalParkingRecord(receiptNum, out parkingRecordsID, out userID, out numberPlate, out realParkTime))
                    {
                        return;
                    }
                    string remoteParkRecordsSql = "select parkingRecordsID from parkingrecords where receiptNum = " + receiptNum + ";";
                    try
                    {
                        object[] result = Monitor.Monitor.remoteDBOper.Query(remoteParkRecordsSql);
                        if(result!=null && result.Length > 0) { remoteParkingRecordsID = (int)result[0]; }
                        //MySqlDataReader reader = Monitor.Monitor.remoteDBOper.Query(remoteParkRecordsSql);
                        //if (reader != null && reader.Read())
                        //{
                        //    object[] receiver = new object[1];
                        //    reader.GetValues(receiver);
                        //    remoteParkingRecordsID = (int)receiver[0];
                        //}
                        //if (reader != null)
                        //{
                        //    reader.Close();
                        //    reader.Dispose();
                        //}
                    }
                    catch (Exception e) { Console.WriteLine(e.Message); }
                    //شںƣ
                    if (numberPlate != "")
                    {
                        //2.ݺƲѯ¿ϢԤԼ¼
                        int orderRecordsID = 0;
                        int monthCardType = -1;
                        string monthCardTime = "";
                        TimeSpan monthCardTimeLength = new TimeSpan(0);
                        TimeSpan orderTimeLength = new TimeSpan(0);
                        //VIPϢ
                        string vipInfoSql = "select orderRecordsID,monthCardType,monthCardTime from vehicle where numberPlate = '" + numberPlate + "';";
                        try
                        {
                            object[] result = Monitor.Monitor.localDBOper.Query(vipInfoSql);
                            //MySqlDataReader reader = Monitor.Monitor.localDBOper.Query(vipInfoSql);
                            //if (reader != null && reader.Read())
                            if (result!=null && result.Length>=3)
                            {
                                //object[] receiver = new object[3];
                                //reader.GetValues(receiver);

                                //if (!receiver[0].GetType().Equals(typeof(DBNull)))
                                //{
                                //    orderRecordsID = (int)receiver[0];
                                //}
                                //if (!receiver[1].GetType().Equals(typeof(DBNull)))
                                //{
                                //    monthCardType = (int)(UInt32)receiver[1];
                                //}
                                //if (!receiver[2].GetType().Equals(typeof(DBNull)))
                                //{
                                //    monthCardTime = (string)receiver[2];
                                //}
                                if (!result[0].GetType().Equals(typeof(DBNull)))
                                {
                                    orderRecordsID = (int)result[0];
                                }
                                if (!result[1].GetType().Equals(typeof(DBNull)))
                                {
                                    monthCardType = (int)(UInt32)result[1];
                                }
                                if (!result[2].GetType().Equals(typeof(DBNull)))
                                {
                                    monthCardTime = (string)result[2];
                                }

                                monthCardTimeLength = DateTime.Parse(monthCardTime) - DateTime.Now;
                                if (monthCardTimeLength.TotalHours <= 0)
                                {
                                    monthCardType = 0;
                                }
                                Log.WriteLog(LogType.process, LogFile.INFO, "ѻȡԤԼ¿Ϣ");
                            }
                            //if (reader != null)
                            //{
                            //    reader.Close();
                            //    reader.Dispose();
                            //}
                        }
                        catch (Exception e) { Console.WriteLine(e.Message); }
                        //ƶVIPϢ
                        try
                        {
                            object[] result = Monitor.Monitor.remoteDBOper.Query(vipInfoSql);
                            //MySqlDataReader reader = Monitor.Monitor.remoteDBOper.Query(vipInfoSql);
                            //if (reader != null && reader.Read())
                            if(result!=null && result.Length>=3)
                            {
                                //object[] receiver = new object[3];
                                //reader.GetValues(receiver);
                                //int cardType = (int)(UInt32)receiver[1];
                                //string CardTime = (string)receiver[2];
                                int cardType = (int)(UInt32)result[1];
                                string CardTime = (string)result[2];
                                TimeSpan t = DateTime.Parse(CardTime) - DateTime.Now;
                                //ƶ
                                if (t.TotalHours > 0 && cardType > monthCardType)
                                {
                                    monthCardType = cardType;
                                    monthCardTimeLength = t;
                                }
                                Log.WriteLog(LogType.process, LogFile.INFO, "ѻȡƶԤԼ¿Ϣ");
                            }
                            //if (reader != null)
                            //{
                            //    reader.Close();
                            //    reader.Dispose();
                            //}
                        }
                        catch (Exception e) { Console.WriteLine(e.Message); }

                        //ԤԼ¼жϼ¼ЧԣЧȡԤԼʱ
                        if (orderRecordsID != 0)
                        {
                            //޸orderTimeLength
                        }

                        //3.ȡͣʱ̣ûͼƷѷ͸PLCΪԤԼ
                        DateTime parkTime = DateTime.Parse(realParkTime);
                        DateTime currentTime = DateTime.Now;
                        int fee = 32767;
                        if (PaymentScheme.ins != null && monthCardType != -1)
                        {
                            if (monthCardTimeLength.TotalHours > 0)
                            {
                                fee = 0;
                            }
                            else
                            {
                                fee = FeeCalc(PaymentScheme.ins, parkTime, orderTimeLength);
                            }
                            try
                            {
                                if (Monitor.Monitor.PLC != null)
                                {
                                    TerminalStru FeeMsg = new TerminalStru();
                                    FeeMsg.terminalID = (short)termIndex;
                                    FeeMsg.paymentStatus = (short)-1;
                                    FeeMsg.licVerification = (short)-1;
                                    FeeMsg.parkingFee = (short)fee;
                                    FeeMsg.userType = (short)(monthCardType + 1);
                                    Console.WriteLine(FeeMsg);
                                    Monitor.Monitor.PLC.WriteToPLC(FeeMsg, PLCDataType.central);
                                    Log.WriteLog(LogType.process, LogFile.INFO, "ͣѷPLC");
                                }
                            }
                            catch { Console.WriteLine("error"); }
                        }
                        //4.ȴն˻շźҽƾ֤շźŲϢдݿ
                        while (!isClosing && termIndex != -1)
                        {
                            if (terminalInfo[termIndex - 1].receiptNum == 0)
                            {
                                Log.WriteLog(LogType.process, LogFile.INFO, "⵽ƾ֤ѱ");
                                TerminalStru fetchReset = new TerminalStru
                                {
                                    terminalID = (short)termIndex,
                                    paymentStatus = (short)0,
                                    licVerification = (short)0,
                                    parkingFee = (short)32767,
                                    userType = (short)0
                                };
                                Monitor.Monitor.PLC.WriteToPLC(fetchReset, PLCDataType.central);
                                //ͣ¼복״̬
                                string updateParkingRecordsSql = "update parkingrecords set parkingRecordsState = 6,realGetTime = '" + currentTime.ToString("yyyy-MM-dd HH:mm:ss") + 
                                "',parkingPrice = " + fee + " where receiptNum = '" + receiptNum + "';";
                                List<string> list = new List<string>();
                                list.Add(updateParkingRecordsSql);

                                lock (Monitor.Monitor.localDBOper)
                                {
                                    Monitor.Monitor.localDBOper.UpdateTransaction(list);
                                    UpdateVehicle(numberPlate, 0, parkingRecordsID, false, false, 0);
                                }
                                lock (Monitor.Monitor.remoteDBOper)
                                {
                                    Monitor.Monitor.remoteDBOper.UpdateTransaction(list);
                                    UpdateVehicle(numberPlate, 0, remoteParkingRecordsID, false, true, 0);
                                }
                                break;
                            }
                            Thread.Sleep(1000);
                        }
                    }
                    termUsedMap[termIndex] = false;
                });
            }
        }

        /// <summary>
        /// ȡز
        /// 
        /// </summary>
        private static void FetchProcess()
        {
            Task.Factory.StartNew(() =>
            {
                while (!isClosing)
                {
                    FetchFeeCalcSubProcess();
                    Thread.Sleep(Monitor.Monitor.plcRefreshInterval);
                }
            });

        }

        public static void Start()
        {
            ParkProcess();
            FetchProcess();
        }

        public static void Stop()
        {
            isClosing = true;
        }
    }
    public class PaymentScheme
    {
        public static PaymentScheme ins;
        public int paymentSchemeID;
        /// <summary>
        /// ͡1ʱ2Σ3ʱ
        /// </summary>
        public int schemeType;
        /// <summary>
        /// ʱ
        /// </summary>
        public int freeTime;
        //******************** ʱշ *******************
        /// <summary>
        /// ׶շʱ
        /// </summary>
        public int firstChargeTime;
        /// <summary>
        /// ׶η
        /// </summary>
        public int firstCharge;
        /// <summary>
        /// շʱ
        /// </summary>
        public int chargeInterval;
        /// <summary>
        /// շѵ
        /// </summary>
        public int intervalCharge;
        /// <summary>
        /// ÿͣշ
        /// </summary>
        public int upperBound;
        //******************** շ *******************
        /// <summary>
        /// շѣÿη
        /// </summary>
        public int eachCharge;
        /// <summary>
        /// շѣչҹ
        /// </summary>
        public int overnightCharge;
        //******************** ʱշ *******************
        /// <summary>
        /// ʱշѣʼʱ
        /// </summary>
        public string startChargeTime;
        /// <summary>
        /// ʱշѣֹʱ
        /// </summary>
        public string endChargeTime;
        /// <summary>
        /// ʱշѣÿСʱ
        /// </summary>
        public int chargeStandard;
        //******************** VIP *******************
        /// <summary>
        /// ¿۸
        /// </summary>
        public int monthCardCharge;
        /// <summary>
        /// ۸
        /// </summary>
        public int seasonCardCharge;
        /// <summary>
        /// 꿨۸
        /// </summary>
        public int halfYearCardCharge;
        /// <summary>
        /// 꿨۸
        /// </summary>
        public int yearCardCharge;
        /// <summary>
        /// ԤԼСʱ
        /// </summary>
        public int bookCharge;

        public PaymentScheme()
        {
            this.paymentSchemeID = 0;
            this.schemeType = 0;
            this.freeTime = 0;
            this.firstChargeTime = 0;
            this.firstCharge = 0;
            this.chargeInterval = 0;
            this.upperBound = 0;
            this.eachCharge = 0;
            this.overnightCharge = 0;
            this.startChargeTime = "";
            this.endChargeTime = "";
            this.chargeStandard = 0;
            this.monthCardCharge = 0;
            this.seasonCardCharge = 0;
            this.halfYearCardCharge = 0;
            this.yearCardCharge = 0;
            this.bookCharge = 0;
        }
        public PaymentScheme(int pID, int type, int freeTime, int firstChargeTime, int firstCharge, int chargeInterval, int intervalCharge,
            int upperBound, int eachCharge, int overnightCharge, string startChargeTime, string endChargeTime, int chargeStandard,
            int monthCardCharge, int seasonCardCharge, int halfYearCardCharge, int yearCardCharge, int bookCharge)
        {
            ins = new PaymentScheme();
            ins.paymentSchemeID = pID;
            ins.schemeType = type;
            ins.freeTime = freeTime;
            ins.firstChargeTime = firstChargeTime;
            ins.firstCharge = firstCharge;
            ins.chargeInterval = chargeInterval;
            ins.intervalCharge = intervalCharge;
            ins.upperBound = upperBound;
            ins.eachCharge = eachCharge;
            ins.overnightCharge = overnightCharge;
            ins.startChargeTime = startChargeTime;
            ins.endChargeTime = endChargeTime;
            ins.chargeStandard = chargeStandard;
            ins.monthCardCharge = monthCardCharge;
            ins.seasonCardCharge = seasonCardCharge;
            ins.halfYearCardCharge = halfYearCardCharge;
            ins.yearCardCharge = yearCardCharge;
            ins.bookCharge = bookCharge;
        }
        public static PaymentScheme GetCurrentPaymentScheme(int index)
        {
            string currentPaymentSchemeQuerySql = "select * from paymentScheme where paymentSchemeID = " + index + ";";
            object[] paramArray = null;
            PaymentScheme scheme = null;
            try
            {
                MySqlDataReader reader = Monitor.Monitor.localDBOper.Query(currentPaymentSchemeQuerySql);
                if (reader != null && reader.Read())
                {
                    scheme = new PaymentScheme();
                    paramArray = new object[reader.FieldCount];
                    reader.GetValues(paramArray);
                    scheme.paymentSchemeID = index;
                    scheme.schemeType = (int)((UInt32)paramArray[1]);
                    scheme.freeTime = (int)paramArray[2];
                    scheme.firstChargeTime = (int)paramArray[3];
                    scheme.firstCharge = (int)paramArray[4];
                    scheme.chargeInterval = (int)paramArray[5];
                    scheme.intervalCharge = (int)paramArray[6];
                    scheme.upperBound = (int)paramArray[7];
                    scheme.eachCharge = (int)paramArray[8];
                    scheme.overnightCharge = (int)paramArray[9];
                    scheme.startChargeTime = (string)paramArray[10];
                    scheme.endChargeTime = (string)paramArray[11];
                    scheme.chargeStandard = (int)paramArray[12];
                    scheme.monthCardCharge = (int)paramArray[13];
                    scheme.seasonCardCharge = (int)paramArray[14];
                    scheme.halfYearCardCharge = (int)paramArray[15];
                    scheme.yearCardCharge = (int)paramArray[16];
                    scheme.bookCharge = (int)paramArray[17];
                }
                if (reader != null)
                {
                    reader.Close();
                    reader.Dispose();
                }
            }
            catch (Exception e) { Console.WriteLine("ȡؼƷѲԣ" + e.Message); }
            return scheme;
        }
    }
}

