﻿using MyNumMachineManager;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Interop;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace NumMachineTest
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : Window
    {
        NumMachineLinker nml;
        public MainWindow()
        {
            InitializeComponent();
            IntPtr flpHandle = flowLayoutPanel1.Handle;
            nml = new NumMachineLinker(flpHandle);
            nml.Start();
        }

        private void win_Closed(object sender, EventArgs e)
        {
            if (nml != null) { nml.Stop(); }
            Close();
            System.Environment.Exit(0);
        }
    }
}
